
/* grace library dsl */

// #t and #f

1 0 > '#t def
1 0 < '#f def

// source quote

["'" scan cat quote eval] 'qquot defun
[scan quote] 'squot defun

// prefix macros

[qquot squot swap defmac] 'defmac: defmac
defmac: defun: [qquot squot swap defun]
defmac: def:   [qquot squot swap def]
defmac: while: [squot squot swap 'while]
defmac: if:    [squot squot swap 'if]
defmac: ife:   [squot squot squot -rot swap 'ife]
defmac: cond:  [squot 'cond]
defmac: map:   [squot 'map]

// verbose scanning

// [ scan dup "[scanning " swap cat "]" cat pr cr ] 'scan defun

// cond : [[cond.0] [cons.0]...[cond.n] [cons.n]] - ?

defun: cond
[
  while: [dup length 0 >]
  [
    ife: [split dive eval]
      [soar splits nip eval []]
      [soar splits drop]
  ]
  drop
]

/* misc */

// variable with resulting source

"" 'src def
// defun: srcat [ds src ds swap ds cat ds 'src ds set ds]
defun: srcat [src swap cat 'src set]

// generates associative array with
// description of library function
// from inline dsl source code
defmac: fun
[
  // create associative array
  new-asa
  // function declaration
  scan "name" rot put
  // expecting ":"
  ["':' expected" pr cr] scan ":" = not if
  // parameters until "-"
  [] while: [scan dup "-" !=] [scons] drop
  "pars" rot put
  // results until ";"
  [] while: [scan dup ";" !=] [scons] drop
  "rets" rot put
  // code until "`"
  "" while: [read 2chr dup "`" !=] [cat] drop
  "code" rot put
]

defun: ncr [while: [dup 0 >][cr 1 -] drop]

defmac: info: ["\"" scan "\"" cat cat quote 'cr 'pr 'cr 'ds]

// generates d source code from
// description of library function
defun: tosrc
[ // : asa -
  // : asa
  "void p_" srcat
  "name" over get srcat
  "()\n{\n" srcat
  // declare and pop parameters
//  "pars:" pr dup pr cr
  "pars" over get reverse enter
  while: [depth 1 >]
  [
    "  " srcat
    swap dup srcat
    " " srcat
    swap srcat
    "=dpop_" srcat
    srcat
    "();\n" srcat
  ]
  leave drop
  // declare return values
//  "ret1:" pr dup pr cr
  "rets" over get enter
  while: [depth 1 >]
  [
    "  " srcat
    srcat
    " " srcat
    srcat
    ";\n" srcat
  ]
  leave drop
  // paste code
//  "code:" pr dup pr cr
  "code" over get
  srcat
  // push return values
//  "ret2:" pr dup pr cr
  "rets" over get enter
  while: [depth 1 >]
  [
    "\n  dpush_" srcat
    srcat
    "(" srcat
    srcat
    ");" srcat
  ]
  leave drop
  //
  "\n}\n" srcat
  // drop asa
  drop
]

// test function library
[
fun add : int a int b - int c ;
  c=a+b;
`

fun sub : int a int b - int c ;
  c=a-b;
`

fun swap : int p1 int p0 - int r1 int r0 ;
  r1=p0;
  r0=p1;
`
]
// "xxx" pr cr

map: [dup pr cr] // pr cr]
map: [dup tosrc] drop

src "test.txt" file-wrstr
