
"
/*
 * MyDll demonstration of how to write D DLLs.
 */

import std.c.stdio;
import std.c.stdlib;
import std.string;
import std.c.windows.windows;
import std.gc;

HINSTANCE   g_hInst;

extern (C)
{
void _minit();
void _moduleCtor();
void _moduleDtor();
void _moduleUnitTests();
}

extern (Windows)
    BOOL DllMain(HINSTANCE hInstance, ULONG ulReason, LPVOID pvReserved)
{
    switch (ulReason)
    {
        case DLL_PROCESS_ATTACH:
    printf(\"DLL_PROCESS_ATTACH\n\");
    break;

        case DLL_PROCESS_DETACH:
    printf(\"DLL_PROCESS_DETACH\n\");
    std.c.stdio._fcloseallp = null; // so stdio doesn't get closed
    break;

        case DLL_THREAD_ATTACH:
    printf(\"DLL_THREAD_ATTACH\n\");
    return false;

        case DLL_THREAD_DETACH:
    printf(\"DLL_THREAD_DETACH\n\");
    return false;
    }
    g_hInst = hInstance;
    return true;
}

export void MyDLL_Initialize(void* gc)
{
    printf(\"MyDLL_Initialize()\n\");
    std.gc.setGCHandle(gc);
    _minit();
    _moduleCtor();
//  _moduleUnitTests();
}

export void MyDLL_Terminate()
{
    printf(\"MyDLL_Terminate()\n\");
    _moduleDtor();// run module destructors
    std.gc.endGCHandle();
}

static this()
{
    printf(\"static this for mydll\n\");
}

static ~this()
{
    printf(\"static ~this for mydll\n\");
}

/* --------------------------------------------------------- */

extern (Windows) export
void job1()
{
  printf(\"hello world!\n\");
}

extern (Windows) export
char[][] job2()
{
  return [\"a\",\"b\",\"c\"];
}
" "tstdll.d" file-wrstr

"
LIBRARY         TSTDLL
DESCRIPTION     'tstDll demonstration DLL'
EXETYPE         NT
CODE            PRELOAD DISCARDABLE
DATA            PRELOAD SINGLE
EXPORTS         job1         job1
EXPORTS         job2         job2
" "tstdll.def" file-wrstr

"dmd tstdll.d tstdll.def" system pr cr

0 "tstdll.dll" load-module

